package io.confluent.kafkarest.entities.v3;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.google.common.collect.ImmutableList;
import java.util.List;
import javax.annotation.Generated;

@Generated("com.google.auto.value.processor.AutoValueProcessor")
final class AutoValue_CreateTopicRequest extends CreateTopicRequest {

  private final String topicName;

  private final int partitionsCount;

  private final short replicationFactor;

  private final ImmutableList<CreateTopicRequest.ConfigEntry> configs;

  private AutoValue_CreateTopicRequest(
      String topicName,
      int partitionsCount,
      short replicationFactor,
      ImmutableList<CreateTopicRequest.ConfigEntry> configs) {
    this.topicName = topicName;
    this.partitionsCount = partitionsCount;
    this.replicationFactor = replicationFactor;
    this.configs = configs;
  }

  @JsonProperty("topic_name")
  @Override
  public String getTopicName() {
    return topicName;
  }

  @JsonProperty("partitions_count")
  @Override
  public int getPartitionsCount() {
    return partitionsCount;
  }

  @JsonProperty("replication_factor")
  @Override
  public short getReplicationFactor() {
    return replicationFactor;
  }

  @JsonProperty("configs")
  @Override
  public ImmutableList<CreateTopicRequest.ConfigEntry> getConfigs() {
    return configs;
  }

  @Override
  public String toString() {
    return "CreateTopicRequest{"
        + "topicName=" + topicName + ", "
        + "partitionsCount=" + partitionsCount + ", "
        + "replicationFactor=" + replicationFactor + ", "
        + "configs=" + configs
        + "}";
  }

  @Override
  public boolean equals(Object o) {
    if (o == this) {
      return true;
    }
    if (o instanceof CreateTopicRequest) {
      CreateTopicRequest that = (CreateTopicRequest) o;
      return this.topicName.equals(that.getTopicName())
          && this.partitionsCount == that.getPartitionsCount()
          && this.replicationFactor == that.getReplicationFactor()
          && this.configs.equals(that.getConfigs());
    }
    return false;
  }

  @Override
  public int hashCode() {
    int h$ = 1;
    h$ *= 1000003;
    h$ ^= topicName.hashCode();
    h$ *= 1000003;
    h$ ^= partitionsCount;
    h$ *= 1000003;
    h$ ^= replicationFactor;
    h$ *= 1000003;
    h$ ^= configs.hashCode();
    return h$;
  }

  static final class Builder extends CreateTopicRequest.Builder {
    private String topicName;
    private Integer partitionsCount;
    private Short replicationFactor;
    private ImmutableList<CreateTopicRequest.ConfigEntry> configs;
    Builder() {
    }
    @Override
    public CreateTopicRequest.Builder setTopicName(String topicName) {
      if (topicName == null) {
        throw new NullPointerException("Null topicName");
      }
      this.topicName = topicName;
      return this;
    }
    @Override
    public CreateTopicRequest.Builder setPartitionsCount(int partitionsCount) {
      this.partitionsCount = partitionsCount;
      return this;
    }
    @Override
    public CreateTopicRequest.Builder setReplicationFactor(short replicationFactor) {
      this.replicationFactor = replicationFactor;
      return this;
    }
    @Override
    public CreateTopicRequest.Builder setConfigs(List<CreateTopicRequest.ConfigEntry> configs) {
      this.configs = ImmutableList.copyOf(configs);
      return this;
    }
    @Override
    public CreateTopicRequest build() {
      String missing = "";
      if (this.topicName == null) {
        missing += " topicName";
      }
      if (this.partitionsCount == null) {
        missing += " partitionsCount";
      }
      if (this.replicationFactor == null) {
        missing += " replicationFactor";
      }
      if (this.configs == null) {
        missing += " configs";
      }
      if (!missing.isEmpty()) {
        throw new IllegalStateException("Missing required properties:" + missing);
      }
      return new AutoValue_CreateTopicRequest(
          this.topicName,
          this.partitionsCount,
          this.replicationFactor,
          this.configs);
    }
  }

}
